# description: this script makes a tiny url from long url (script using tinyurl.com), send long_url to bot via a msg command,  you can set minimum length of long_url,

# Author: tomekk
# e-mail:  tomekk/@/oswiecim/./eu/./org
# home page: http://tomekk.oswiecim.eu.org/
#
# Version 0.7
#
# This file is Copyrighted under the GNU Public License.
# http://www.gnu.org/copyleft/gpl.html 

# use: /msg <botnick> tiny <long_url>

# added: you can choose now how the bot should output the 'short link', msg to the defined channel or notice to the user
# fixed: some tiny code fix
# fixed: from this ver, informations goes via NOTICEs

# channel to output
set tiny_chan "#channel"

# output type
# 0 - defined channel, 1 - notice to user
set output_type 1

# use regex, 
# 1 - yes, link must begin with ftp://, http:// or https://,
# 0 - no, link can begin with any chars
set link_regex 0

# min length of link (chars)
set min_length 40

# interval between use (in seconds)
set tiny_use_interval 20

# http connection timeout (in seconds)
set get_url_timeout 10

#############################################################################
bind msgm - "*" tiny_fct

package require http

set set_use_time 1

proc tiny_fct { nick uhost hand arg } {
	global min_length tiny_chan set_use_time tiny_use_interval link_regex output_type

	set msg_txt [split $arg]
	set ack_time [clock seconds]
	set tiny_cmd [lindex $msg_txt 0]
	set big_link [lrange $msg_txt 1 end]
	set link_is_ok 1	

	if {$tiny_cmd == "tiny"} {
		if {$big_link != ""} {
			if {$link_regex == 1} {
				if {![regexp {^(f|ht)tp(s|)://} $big_link]} {
					set link_is_ok 0
				}
			}

			if {$link_is_ok == 1} {
				if {[expr $ack_time - $set_use_time] >= $tiny_use_interval} {
					set link_length [string length $big_link]
					if {$link_length >= $min_length} {
						set tiny_link [grab_data $big_link]
						if {$tiny_link != "error"} {
							if {$output_type == 0} {
								putquick "PRIVMSG $tiny_chan :$tiny_link (link by $nick)"
							} {
								putquick "NOTICE $nick :your short link: $tiny_link"
							}
							set set_use_time [clock seconds]
						} {
							putquick "NOTICE $nick :sorry, something is wrong with tinyurl.com, please try again later"
						}
					} {
						putquick "NOTICE $nick :link is to short (minimum length of the url is set to $min_length chars)"
					}
				} {
					putquick "NOTICE $nick :using interval is set to $tiny_use_interval seconds"
				}
			} {
				putquick "NOTICE $nick :bad url format, link must begin with ftp://, http:// or https://"
			}
		} {
			putquick "NOTICE $nick :use: /msg <botname> tiny <long_url>"
		}
	} 
}

proc grab_data { url } {
	global get_url_timeout
	
	set uagent "tktiny.tcl <eggdrop script>"

	set tiny_form "http://tinyurl.com/api-create.php"

	set tiny_token [http::config -useragent $uagent]

	set tiny_token [http::geturl $tiny_form -query [http::formatQuery "url" $url] -timeout [expr $get_url_timeout * 1000]]

	set html_data [http::data $tiny_token]

	if {$html_data != ""} {
		return $html_data
	} {
		return "error"
	}
}

putlog "tktiny.tcl ver 0.7 by tomekk loaded"

